<?php 

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class CancelamentoServico {
    
	protected $entityManager; 

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    private function setReportParameters(&$params, &$conditions) {
        $params = array(
            ':DATAINI' => isset($conditions['DATAINI']) ? $conditions['DATAINI'] : null ,
            ':DATAFIN' => isset($conditions['DATAFIN']) ? $conditions['DATAFIN'] : null ,
            ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null ,
            ':CDLOJA' => isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : null ,
            ':TCDLOJA' => isset($conditions['TCDLOJA']) ? $conditions['TCDLOJA'] : null ,
            ':CDVENDEDOR' => isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] : null ,
            ':TCDVENDEDOR' => isset($conditions['TCDVENDEDOR']) ? $conditions['TCDVENDEDOR'] : isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] == null ? 'T' : 'F' : 'T',
            ':NRORG' => $conditions['NRORG']
        );
    } 
    
    public function getCancelamentoServico($conditions) {
    	$params = [];
        $this->setReportParameters($params, $conditions);
        return $this->entityManager->getConnection()->fetchAll(self::REL_CANCELAMENTO_SERVICO_ACRESCIMO, $params);
    }

    const REL_CANCELAMENTO_SERVICO_ACRESCIMO = "
        SELECT LABELFILIAL ||' - Loja:' ||LABELLOJA AS LABELFILIAL, GARCON, CDLOJA, CDFILIAL, CDCAIXA, NRSEQVENDA, VRCOMISVENDA, DTENTRVENDA, NRMESA,CDVENDEDOR,
          CDSUPERVISOR, VRTOTPROD, VRGORJETA, VRTOTGOR, DESCGORJ, NRORG, CDFAMILISALD, TRUNC(((VRGORJETA/VRTOTPROD)*100),2) AS PERCENT, NRINSJURVEN,
          OPERADOR
        FROM
          (SELECT V.CDFILIAL ||' - ' ||F.NMFILIAL AS LABELFILIAL, L.CDLOJA ||' - ' ||L.NMLOJA AS LABELLOJA,
             DECODE (V.CDVENDEDOR ||' ' ||VE.NMRAZSOCVEN, ' ', 'Venda Sem Garçon', V.CDVENDEDOR ||' ' ||VE.NMRAZSOCVEN) AS GARCON,L.CDLOJA, V.CDFILIAL, V.CDCAIXA,
             V.NRSEQVENDA, L.VRCOMISVENDA, V.DTENTRVENDA, V.NRMESA, V.CDVENDEDOR AS CDVENDEDOR,
             VE.VRPERCCOMISVEND, V.CDSUPERVISOR ||' - ' ||O.NMOPERADOR AS CDSUPERVISOR, SUM ((I.QTPRODVEND * (I.VRUNITVEND - I.VRDESITVEND))) AS VRTOTPROD,
             SUM(NVL(I.VRACRITVEND,0)) AS VRGORJETA, TRUNC((SUM (((I.QTPRODVEND * (I.VRUNITVEND - I.VRDESITVEND))) * (L.VRCOMISVENDA/100))) - SUM(I.VRACRITVEND),2) AS DESCGORJ,
             TRUNC(SUM ((I.QTPRODVEND * (I.VRUNITVEND - I.VRDESITVEND)) * (DECODE (L.IDCOMISVENDA, 'S', L.VRCOMISVENDA, 'G', DECODE(VE.IDVRINCIDECONTA, 'S', VE.VRPERCCOMISVEND, 0))/100)), 2) AS VRTOTGOR,
             V.NRORG, I.CDFAMILISALD, VE.NRINSJURVEN, PR.IDCOBTXSERV, V.CDOPERADOR, OP1.NMOPERADOR AS OPERADOR
           FROM VENDA V  
           LEFT JOIN OPERADOR OP1
            ON OP1.CDOPERADOR   = V.CDOPERADOR
             AND V.NRORG = OP1.NRORG
           JOIN ITEMVENDA I 
            ON V.CDFILIAL = I.CDFILIAL
             AND V.CDCAIXA = I.CDCAIXA
             AND V.NRSEQVENDA = I.NRSEQVENDA
             AND V.NRORG = I.NRORG
           JOIN PRODUTO PR
            ON PR.CDPRODUTO = I.CDPRODUTO
             AND PR.NRORG = I.NRORG
           JOIN FILIAL F
            ON V.CDFILIAL = F.CDFILIAL
             AND I.CDFILIAL = F.CDFILIAL
             AND V.NRORG = F.NRORG
           JOIN LOJA L
           ON V.CDFILIAL = L.CDFILIAL
             AND V.CDLOJA = L.CDLOJA
             AND F.CDFILIAL = L.CDFILIAL
             AND V.NRORG = L.NRORG
           LEFT JOIN OPERADOR O 
            ON V.CDSUPERVISOR = O.CDOPERADOR
             AND V.NRORG = O.NRORG
           LEFT JOIN VENDEDOR VE 
            ON V.CDVENDEDOR = VE.CDVENDEDOR
             AND V.NRORG = VE.NRORG
           WHERE L.IDCOMISVENDA IN ('S', 'G')
             AND V.IDSITUVENDA = 'O'
             AND SUBSTR(V.IDORIGEMVENDA, 0, 3) <> 'DLV'
             AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
             AND ((INSTR(:CDVENDEDOR, NVL(I.CDVENDEDOR,V.CDVENDEDOR)) <> 0) OR (:TCDVENDEDOR = 'T'))
             AND ((INSTR(:CDLOJA, V.CDLOJA) <> 0) OR (:TCDLOJA = 'T'))
             AND ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0))
             AND V.NRORG = :NRORG
             AND  PR.IDCOBTXSERV = 'S'
           GROUP BY F.NMFILIAL, L.NMLOJA, V.NRSEQVENDA, V.CDSUPERVISOR, V.CDOPERADOR, V.NRMESA, V.DTENTRVENDA, O.NMOPERADOR, V.CDVENDEDOR, VE.VRPERCCOMISVEND, L.CDLOJA,
             V.CDFILIAL, V.CDCAIXA, L.VRCOMISVENDA, V.NRORG, VE.NMRAZSOCVEN, I.CDFAMILISALD, VE.NRINSJURVEN,  PR.IDCOBTXSERV, V.CDOPERADOR, OP1.NMOPERADOR 
          )
        WHERE VRTOTGOR > VRGORJETA
        ORDER BY CDFILIAL, CDCAIXA, DTENTRVENDA, NRSEQVENDA
    ";
    
}